<template>
	<div class="no-block-spacing">
		<ProviderRecaptcha
			v-slot="{ runRecaptcha, recaptchaReset }"
			:recaptcha-container-id="recaptchaContainerId"
			wait-to-initialize
		>
			<SlicesRenderer v-bind="{ sliceComponents }">
				<template #default="{ slice, index }">
					<div v-if="slice && slice.sliceType === 'IntakeForm'" :key="index">
						<FormSpecRenderer
							:ref="`formSpecRenderer-${index}`"
							:spec="getFormSpec(index)"
							:is-working="isWorking"
							:cta-text="slice.props.ctaText"
							:max-width="slice.props.containerMaxWidth"
							style-variation="secondary"
							@submit="
								(data) =>
									submit(
										data,
										runRecaptcha,
										recaptchaReset,
										`recaptcha-container-${index}`,
										`formSpecRenderer-${index}`
									)
							"
						>
							<template v-if="$hasRichText(slice.props.headerCopy)" #header>
								<div :class="[$style.content, $style.formHeader]" v-html="slice.props.headerCopy" />
							</template>
							<template v-if="error" #error>
								<div role="alert" :class="$style.error">
									{{ error }}
								</div>
							</template>
							<template v-if="$hasRichText(slice.props.footerCopy)" #below-form>
								<div :class="[$style.content, $style.formFooter]" v-html="slice.props.footerCopy" />
							</template>
						</FormSpecRenderer>
						<div :id="`recaptcha-container-${index}`" />
					</div>
				</template>
			</SlicesRenderer>
		</ProviderRecaptcha>
	</div>
</template>

<script>
import ProviderRecaptcha from '@components/provider-recaptcha';
import SlicesRenderer from '@components/slices-renderer';
import FormSpecRenderer from '@components/form-spec-renderer';
import FormInput from '@components/form-input';
import FormSelect from '@components/form-select';
import FormTextarea from '@components/form-textarea';
import FormCheckbox from '@components/form-checkbox';
import getMetadata from '@/utils/get-metadata';
import { camelToSnakeCase } from '@/utils';
import { loadComponentsBeforeRender, getSliceComponents } from '@/utils/async-components-helpers';
const formComponents = { FormInput, FormSelect, FormTextarea, FormCheckbox };

// prettier-ignore
const states = ['State', 'AL','AK','AS','AZ','AR','CA','CO','CT','DE','DC','FM','FL','GA','GU','HI','ID','IL','IN','IA','KS','KY','LA','ME','MH','MD','MA','MI','MN','MS','MO','MT','NE','NV','NH','NJ','NM','NY','NC','ND','MP','OH','OK','OR','PW','PA','PR','RI','SC','SD','TN','TX','UT','VT','VI','VA','WA','WV','WI','WY'].map((state) => ({ value: state, text: state }));

export default {
	components: {
		ProviderRecaptcha,
		SlicesRenderer,
		FormSpecRenderer,
		...formComponents,
	},

	beforeRouteEnter: (to, from, next) =>
		next((vm) => {
			if (!vm.isInitialRoute) vm.previousFullPath = from.fullPath;
		}),

	asyncData: async ({ store, req }) => {
		const page = await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'nominate_a_small_business', req });

		await loadComponentsBeforeRender(page.slices);

		return { page, isInitialRoute: process.server };
	},

	data: () => ({
		formSpec: [],
		formSpecLabels: {},
		isWorking: false,
		submittedSuccess: false,
		error: '',
		previousFullPath: '',
		recaptchaContainerId: '',
	}),

	head() {
		return this.page
			? getMetadata(
					{
						...this.page.seo,
						path: this.$route && this.$route.path,
					},
					this.$sentry
			  )
			: {};
	},

	computed: {
		sliceComponents() {
			return getSliceComponents(this.page.slices);
		},
	},

	created() {
		this.formSpec = [
			{
				id: 'yourFirstName',
				component: FormInput,
				label: 'Your First Name *',
				placeholder: 'Your first name',
				required: true,
				appearance: 'halfOnDesktop',
				labelHidden: true,
			},
			{
				id: 'yourLastName',
				component: FormInput,
				label: 'Your Last Name *',
				placeholder: 'Your last name',
				required: true,
				appearance: 'halfOnDesktop',
				labelHidden: true,
			},
			{
				id: 'yourEmail',
				component: FormInput,
				type: 'email',
				label: 'Your Email Address *',
				placeholder: 'Your email address',
				required: true,
				labelHidden: true,
			},
			{ type: 'separator' },
			{
				id: 'businessName',
				component: FormInput,
				label: 'Business Name *',
				placeholder: 'Business name',
				required: true,
				labelHidden: true,
				helperText:
					'The business must have a physical storefront, as confirmed by its website or other online presence.',
			},
			{
				id: 'businessEmail',
				component: FormInput,
				type: 'email',
				label: 'Business Email *',
				placeholder: 'Business email',
				required: true,
				labelHidden: true,
			},
			{
				id: 'businessPhoneNumber',
				component: FormInput,
				type: 'tel',
				label: 'Business Phone Number *',
				placeholder: 'Business phone number',
				required: true,
				labelHidden: true,
			},
			{
				id: 'businessAddress1',
				component: FormInput,
				label: 'Business Street Address 1 *',
				placeholder: 'Business street address 1',
				required: true,
				labelHidden: true,
				helperText: 'This should be the address to the physical storefront.',
			},
			{
				id: 'businessAddress2',
				component: FormInput,
				label: 'Business Street Address 2',
				placeholder: 'Business street address 2',
				labelHidden: true,
			},
			{
				id: 'businessCity',
				component: FormInput,
				labelHidden: true,
				label: 'City *',
				placeholder: 'City',
				required: true,
			},
			{
				id: 'businessState',
				component: FormSelect,
				type: 'select',
				labelHidden: true,
				label: 'State *',
				placeholder: 'State',
				required: true,
				options: states,
				appearance: 'halfOnDesktop',
				default: 'State',
			},
			{
				id: 'businessPostCode',
				component: FormInput,
				labelHidden: true,
				label: 'Zip Code *',
				placeholder: 'Zip code',
				appearance: 'halfOnDesktop',
				required: true,
			},
			{
				id: 'businessPageType',
				component: FormSelect,
				type: 'select',
				labelHidden: true,
				label: 'Business Page Type *',
				placeholder: 'Business page type',
				required: true,
				options: ['Business page type', 'Yelp', 'Google', 'Bing', 'TripAdvisor'].map((type, i) => ({
					value: i === 0 ? '' : type,
					text: type,
				})),
				default: '',
			},
			{
				id: 'businessUrl',
				component: FormInput,
				label: 'Link to Yelp/Google Page/Bing/TripAdvisor *',
				placeholder: 'Link to Yelp/Google Page/Bing/TripAdvisor',
				required: true,
				labelHidden: true,
			},
			{
				id: 'openForm',
				component: FormTextarea,
				labelHidden: true,
				type: 'textarea',
				label: 'Message (optional)',
				placeholder: 'Tell us why you love this business (optional)',
				maxlength: 150,
			},
			{
				id: 'termsAcknowledgement',
				component: FormCheckbox,
				type: 'checkbox',
				label: 'I have read and agree to the Official Rules *',
				displayLabel: '<p>I have read and agree to the <a href="/legal#smbnominate">Official rules</a>.</p>',
				required: true,
				default: false,
			},
		];

		this.formSpec.forEach((field) => {
			this.formSpecLabels[field.id] = field.label;
		});
	},

	methods: {
		async submit(formData, runRecaptcha, recaptchaReset, recaptchaContainerId, refName) {
			const { isWorking } = this;
			if (isWorking) return;
			const { $route, previousFullPath } = this;

			this.recaptchaContainerId = recaptchaContainerId;
			this.isWorking = true;
			this.error = '';

			const formToSubmit = {};
			Object.entries(formData).forEach(([key, value]) => {
				formToSubmit[key] = {
					label: this.formSpecLabels[key],
					value: value === true || value === false ? String(value) : value,
				};
			});

			if ($route.query.utm_source || document.referrer) {
				formToSubmit.channelSource = {
					label: 'Channel source',
					value: $route.query.utm_source || document.referrer,
				};
			}

			if (previousFullPath) {
				formToSubmit.source = {
					label: 'Source',
					value: `${window.location.origin}${previousFullPath}`,
				};
			}

			const originalToTealiumPropNames = {
				yourFirstName: 'form_first_name',
				yourLastName: 'form_last_name',
				yourEmail: 'form_submitee_email',
				businessName: 'form_business_name',
				businessEmail: 'form_other_email',
				businessPhoneNumber: 'form_phone',
				businessAddress1: 'form_address1',
				businessAddress2: 'form_address2',
				businessCity: 'form_city',
				businessState: 'form_state',
				businessPostCode: 'form_zip',
				businessPageType: 'form_choice_picker_1',
				businessUrl: 'form_question_1',
				openForm: 'form_question_2',
				termsAcknowledgement: 'form_question_4',
			};

			const tealiumFormProps = Object.fromEntries(
				Object.entries(formToSubmit).map(([key, { value }]) => [
					originalToTealiumPropNames[key] || `form_${camelToSnakeCase(key)}`,
					value,
				])
			);

			if (tealiumFormProps.form_channel_source) delete tealiumFormProps.form_channel_source;
			if (tealiumFormProps.form_source) delete tealiumFormProps.form_source;

			try {
				const recaptchaResponse = await runRecaptcha();

				const response = await this.$axios.$post('/custom-apis/forms/smb', {
					recaptchaResponse,
					form: formToSubmit,
					type: 'Consumer',
				});

				if (response.success) {
					this.submittedSuccess = true;

					this.$tealiumEvent('form_submit', {
						event_category: 'Promotion Submission',
						event_action: 'Generic Promotional Form',
						event_label: window.location.href,
						...tealiumFormProps,
					});

					const RESPONSE_ROUTE = [this.$router.history.current.name, 'response'].join('-');
					const useRouter = false;
					const responseRoute = this.$router.options.routes.find((r) => r.name === RESPONSE_ROUTE);
					if (useRouter) {
						this.$router.push(responseRoute);
					} else {
						window.location.pathname = responseRoute.path;
					}
				} else {
					throw new Error('returned error');
				}
			} catch (e) {
				this.error = 'Unexpected error occurred. Please try again in a few minutes.';
				this.$tealiumEvent('form_submit_fail', {
					event_category: 'Promotion Submission',
					event_action: 'Generic Promotional Form',
					event_label: window.location.href,
					event_value: 500,
					...tealiumFormProps,
				});
				recaptchaReset();
			} finally {
				this.isWorking = false;
			}
		},

		getFormSpec(index) {
			return this.formSpec.map((field) => ({
				...field,
				labelFor: `${field.id}-${index}`,
			}));
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.header {
	text-align: var(--heading-text-align);

	h1 {
		@include use-text-style('heading-650');
	}

	h2 {
		@include use-text-style('heading-400');
	}

	h3,
	h4,
	h5,
	h6 {
		@include use-text-style('heading-200');
	}

	h1,
	h2,
	h3,
	h4,
	h5,
	h6 {
		margin: 0 auto 1em;
		font-weight: 300;
	}
}

.block {
	padding: 5rem size('s');
	margin: 0 auto;
	line-height: 1.85714;

	button,
	a {
		line-height: 1;
	}
}

.thanksCopy {
	@include use-text-style('type-500');

	font-weight: 300;
	text-align: var(--copy-text-align);

	/* linter doesn't like specificity here */
	/* stylelint-disable */
	p:not(:last-of-type) {
		margin-bottom: 1em;
	}

	h3,
	h4,
	h5,
	h6 {
		@include use-text-style('heading-150');

		margin-bottom: 1em;
		font-weight: 300;
	}
}

.formHeader {
	h1,
	h2,
	h3,
	h4,
	h5,
	h6 {
		text-align: center;
	}
}

.formFooter {
	padding: 4.3rem 0 0;
}

.content {
	line-height: 1.85714;

	p {
		@include use-text-style('type-100');

		font-weight: 300;

		&:not(:last-child) {
			margin-bottom: 1em;
		}
	}

	a {
		text-decoration: underline;
	}

	h2 {
		@include use-text-style('heading-400');
	}

	h3 {
		@include use-text-style('heading-200');
	}

	h4 {
		@include use-text-style('heading-180');
	}

	h5,
	h6 {
		@include use-text-style('heading-150');
	}

	&.hasMarginTop {
		h2,
		h3,
		h4,
		h5,
		h6,
		p {
			&:first-child {
				@include above('medium') {
					margin-top: 1em;
				}
			}
		}
	}

	h2,
	h3,
	h4,
	h5,
	h6 {
		@include font-family('primary');

		font-weight: 300;
		margin-bottom: 1em;

		.layer.__full & {
			text-align: center;
		}
	}
	/* stylelint-enable */
	ul {
		padding: 0;
		margin: 1rem 0 1rem 3rem;

		li {
			padding: 0;
			margin: 0 0 2rem;
			font-weight: 300;

			@include use-text-style('type-200');
		}
	}

	:global(.line-separator) {
		display: block;
		width: 100%;
		height: 1px;
		content: '';
		background: color('primary-250');
	}

	:global(.underline) {
		text-decoration: underline;
	}
}

.ctaSection {
	margin: 3.5rem 0 0;
	text-align: center;
}

.error {
	@include use-text-style('type-300');

	margin-bottom: size('m');
	color: color('red');
}
</style>
